﻿'
Imports System.Data.SqlClient
Imports System.ServiceProcess
Imports Microsoft.Win32
Imports System.ComponentModel
Imports OpcLabs.EasyOpc.DataAccess
Imports OpcLabs.EasyOpc.DataAccess.OperationModel
Imports System.Windows.Forms.Application

<Assembly: CLSCompliant(True)>

Partial Public Class frmDAClient_UI
    Inherits Form
    '
    Dim strHeader As String
    Dim rHive As RegistryHive
    Dim Remove_in_Progress As Boolean = False

    Public Sub New()
        InitializeComponent()
    End Sub
    '
    Private Sub btnStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStart.Click
        Dim i As Integer
        '
        Try
            IsSubscribed = False
            '
            If Not IsNothing(TagTable) And Not IsNothing(ServerTable) Then
                For i = 0 To TagTable.Length - 1
                    TagTable(i).Handle = DAClient1.SubscribeItem(TagTable(i).HostAddress, TagTable(i).ServerName, TagTable(i).TagName, TagTable(i).Interval)
                    If Verbose_Messaging Then Log_Message3("Subscribed - Tag: " & TagTable(i).TagName.Trim & ",  Handle: " & TagTable(i).Handle.ToString &
                                             ",   Computer: " & TagTable(i).HostAddress & ", Server: " & TagTable(i).ServerName)
                Next
            End If
            '
            btnServer.Enabled = False
            btnNode.Enabled = False
            btnStart.Enabled = False
            btnStartService.Enabled = False
            btnStopService.Enabled = False
            DG1.Enabled = False
            btnStop.Enabled = True
            IsSubscribed = True
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "StartButton")
        End Try
    End Sub

    Private Sub btnStop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStop.Click
        Call Unsubscribe()
        '
        btnServer.Enabled = True
        btnNode.Enabled = True
        btnStart.Enabled = True
        DG1.Enabled = True
        btnStop.Enabled = False
        btnStartService.Enabled = True
        btnStopService.Enabled = True
    End Sub
    '
    Sub Unsubscribe()
        Dim i As Short
        '
        Try
            If Not IsNothing(TagTable) Then
                For i = 0 To TagTable.Length - 1
                    DAClient1.UnsubscribeItem(TagTable(i).Handle)
                Next
            End If
            IsSubscribed = False
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "unsubscribe")
        End Try
    End Sub
    '
    Private Sub closeButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles closeButton.Click
        If IsSubscribed Then
            Unsubscribe()
        End If
        Close()
    End Sub

    Private Sub frmUAClient_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Dim i As Short
        Dim S_OPC_ServerName As String
        Dim S_OPC_HostAddress As String
        Dim errInfo As String = ""
        Dim sc As New ServiceController("OPC_DAClient")
        '
        Try
            DAClient1.InstanceParameters.EnableNativeClient = False
            '
            For i = 0 To 8
                DG1.Columns(i).HeaderCell.Style.Alignment = DataGridViewContentAlignment.BottomCenter
            Next
            '
            Try
                If sc.Status = ServiceControllerStatus.Running Then
                    Me.btnStartService.Enabled = False
                    Me.btnStopService.Enabled = True
                    Me.lblService.Text = "Status: Running"
                    Me.lblService.ForeColor = Color.Green
                    Me.btnStart.Enabled = False
                    Me.btnServer.Enabled = False
                    Me.btnNode.Enabled = False
                Else
                    Me.lblService.Text = "Status: Stopped"
                    Me.lblService.ForeColor = Color.Red
                    Me.btnStart.Enabled = True
                    Me.btnServer.Enabled = True
                    Me.btnStartService.Enabled = True
                    Me.btnStopService.Enabled = False
                    Me.btnNode.Enabled = True
                End If
            Catch ex As Exception
                Me.lblService.Text = "Status: No Service Installed"
                Me.lblService.ForeColor = Color.Red
                Call ReportEvent(ex.Message, "Load")
            End Try
            '
            Me.btnStop.Enabled = False
            Me.chkverbose.Checked = True
            '
            S_OPC_ServerName = GetSetting("DCMS", "COMMON", "OPC_DAClient_ServerName", "")
            Me.txtServerName.Text = S_OPC_ServerName
            '
            S_OPC_HostAddress = GetSetting("DCMS", "COMMON", "OPC_DAClient_HostAddress", "")
            Me.txtHostAddress.Text = S_OPC_HostAddress
            '
            strHeader = ".DEFAULT\Software\VB and VBA Program Settings\DCMS\COMMON\"        'For Default user - For running Modbus_Slave as a serviceonly 
            rHive = RegistryHive.Users
            ConnectionString = RegValue(rHive, strHeader, "DAConnectionString", "COM7")
            '
            If ConnectionString = "" Then
                ConnectionString = "Data Source=.\ITRDCMS;Initial Catalog=SupervisingServerDB;Persist Security Info=True;User ID=DCMSU;Password=DcmS1289;Pooling=True;Connection Timeout=120"
            End If
            '
            Dim strArgs() As String = Environment.GetCommandLineArgs
            If strArgs.Length > 1 Then
                If strArgs(1).ToLower = "db" Then
                    frmConnectionString.ShowDialog()
                End If
            End If
            '
            If Not Write_RegValue(rHive, strHeader, "DAConnectionString", ConnectionString, errInfo) Then
                Call ReportEvent("error in storing connection string. " & errInfo, "")
            End If
            '
            Call ReportEvent(ConnectionString, "")
            conn = New SqlConnection(ConnectionString & ";Connection Timeout=300")
            conn.Open()
            '
            Me.lblVersion.Text = "Version: " & Get_Software_Version_2010.ToString
            '
            Call Read_ServerTable()
            If Not IsNothing(ServerTable) Then
                For i = 0 To ServerTable.Length - 1
                    DG2.Rows(i).Selected = False
                    If ServerTable(i).ServerName = S_OPC_ServerName And ServerTable(i).HostAddress = S_OPC_HostAddress Then
                        DG2.Rows(i).Selected = True
                        Exit For
                    End If
                Next
            End If
            '
            DG1.SelectAll()
            DG1.ClearSelection()
            i = DG1.Rows.Count
            Call Read_TAGTable()
            '
            Me.Timermessages.Enabled = True
            Me.Timermessages.Interval = 1000
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, System.Reflection.MethodBase.GetCurrentMethod.DeclaringType.Name & " / " & System.Reflection.MethodBase.GetCurrentMethod().Name)
            End Try
    End Sub
    '
    Public Function RegValue(ByVal Hive As RegistryHive, ByVal Key As String, ByVal ValueName As String, ByRef ErrInfo As String) As String
        Dim objParent As RegistryKey = Nothing
        Dim objSubkey As RegistryKey
        Dim sAns As String = ""
        '
        Try
            Select Case Hive
                Case RegistryHive.ClassesRoot
                    objParent = Registry.ClassesRoot
                Case RegistryHive.CurrentConfig
                    objParent = Registry.CurrentConfig
                Case RegistryHive.CurrentUser
                    objParent = Registry.CurrentUser
                Case RegistryHive.DynData
                    objParent = Registry.PerformanceData
                Case RegistryHive.LocalMachine
                    objParent = Registry.LocalMachine
                Case RegistryHive.PerformanceData
                    objParent = Registry.PerformanceData
                Case RegistryHive.Users
                    objParent = Registry.Users
            End Select

            objSubkey = objParent.OpenSubKey(Key)
            'if can't be found, object is not initialized
            If Not objSubkey Is Nothing Then
                sAns = (objSubkey.GetValue(ValueName))
            End If

        Catch ex As Exception

            ErrInfo = ex.Message
        Finally

            'if no error but value is empty, populate errinfo
            If ErrInfo = "" And sAns = "" Then
                ErrInfo =
                   "No value found for requested registry key"
            End If
        End Try
        Return sAns
    End Function
    '
    Public Function Write_RegValue(ByVal Hive As RegistryHive, ByVal Key As String, ByVal ValueName As String, ByVal Value As String, ByRef ErrInfo As String) As Boolean
        Dim objParent As RegistryKey = Nothing
        Dim objSubkey As RegistryKey
        Dim flag As Boolean = False
        '
        Try
            Select Case Hive
                Case RegistryHive.ClassesRoot
                    objParent = Registry.ClassesRoot
                Case RegistryHive.CurrentConfig
                    objParent = Registry.CurrentConfig
                Case RegistryHive.CurrentUser
                    objParent = Registry.CurrentUser
                Case RegistryHive.DynData
                    objParent = Registry.PerformanceData
                Case RegistryHive.LocalMachine
                    objParent = Registry.LocalMachine
                Case RegistryHive.PerformanceData
                    objParent = Registry.PerformanceData
                Case RegistryHive.Users
                    objParent = Registry.Users
            End Select

            objSubkey = objParent.OpenSubKey(Key, True)
            If Not objSubkey Is Nothing Then
                objSubkey.SetValue(ValueName, Value)
            Else
                objParent.CreateSubKey(Key)
                objSubkey = objParent.OpenSubKey(Key, True)
            End If
            flag = True

        Catch ex As Exception
            ErrInfo = ex.Message
        End Try
        Return flag
    End Function
    '
    Sub Read_TAGTable()
        Dim i As Short = 0
        '
        Try
            DG1.Rows.Clear()
            Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                Dim dataReader As SqlDataReader
                cmd.CommandType = System.Data.CommandType.Text
                cmd.CommandText = "SELECT * FROM tblOPC_DATagName ORDER BY TagName"
                dataReader = cmd.ExecuteReader
                Call ReportEvent("Rows in Tagtable: " & dataReader.HasRows.ToString, "")
                If dataReader.HasRows Then
                    '
                    Do While dataReader.Read()
                        ReDim Preserve TagTable(i)
                        TagTable(i).TagName = (CType(dataReader("TagName"), String)).Trim
                        Call ReportEvent(i.ToString & vbTab & "TagName: " & TagTable(i).TagName, "")
                        '
                        TagTable(i).ServerName = (CType(dataReader("ServerName"), String)).Trim
                        Call ReportEvent(i.ToString & vbTab & "ServerName: " & TagTable(i).ServerName, "")
                        '
                        TagTable(i).HostAddress = (CType(dataReader("HostAddress"), String)).Trim
                        Call ReportEvent(i.ToString & vbTab & "HostAddress: " & TagTable(i).HostAddress, "")
                        '
                        TagTable(i).TagShort = (CType(dataReader("TagShortName"), String)).Trim
                        Call ReportEvent(i.ToString & vbTab & "TagShortName: " & TagTable(i).TagShort, "")

                        TagTable(i).Interval = (CType(dataReader("SampleInterval"), String)).Trim
                        Call ReportEvent(i.ToString & vbTab & "Interval: " & TagTable(i).Interval.ToString, "")
                        '
                        Dim row As String() = New String() {(i + 1).ToString,
                            TagTable(i).TagName,
                            TagTable(i).HostAddress,
                            TagTable(i).ServerName,
                            TagTable(i).TagShort,
                            TagTable(i).Interval.ToString, "", "", ""}
                        DG1.Rows.Add(row)
                        i += 1
                    Loop
                End If
                dataReader.Close()
            End Using
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "Read_Tagtable")
        End Try
    End Sub
    '
    Sub Read_ServerTable()
        Dim dataReader As SqlDataReader
        Dim i As Short = 0
        '
        Try
            Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                cmd.CommandType = System.Data.CommandType.Text
                Erase ServerTable
                cmd.CommandText = "SELECT * FROM tblOPC_DAServer ORDER BY OPC_ServerName"
                dataReader = cmd.ExecuteReader
                If dataReader.HasRows Then
                    If dataReader.HasRows Then
                        DG2.SelectAll()
                        DG2.ClearSelection()
                        Do While dataReader.Read()
                            ReDim Preserve ServerTable(i)
                            ServerTable(i).ServerName = (CType(dataReader("OPC_ServerName"), String)).Trim
                            ServerTable(i).HostAddress = (CType(dataReader("OPC_HostAddress"), String)).Trim
                            DG2.Rows.Add()
                            DG2.Rows(i).Cells(0).Value = ServerTable(i).ServerName
                            DG2.Rows(i).Cells(1).Value = ServerTable(i).HostAddress
                            i += 1
                        Loop
                        Row_Index = 0
                    Else
                        Call ReportEvent("No ServerTable Entries Found", "")
                    End If
                End If
                dataReader.Close()
            End Using
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "Read_Servertable")
        End Try
    End Sub
    '
    Sub Add_NewTagItem(ByVal TagName As String)
        Dim dataReader As SqlDataReader
        Dim i As Short
        Dim flag As Boolean
        Dim QueryString As String = ""
        '
        Try
            Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                cmd.CommandType = System.Data.CommandType.Text
                QueryString = "SELECT * FROM tblOPC_DATagName Where TagName = " & Quote(TagName) &
                    " AND ServerName = " & Quote(OPC_ServerName) & " AND HostAddress = " & Quote(OPC_HostAddress)
                cmd.CommandText = QueryString
                dataReader = cmd.ExecuteReader
                If dataReader.HasRows Then
                    flag = False
                    For i = 0 To TagTable.Length - 1            'Find the row where the tags resides
                        If (CType(DG1.Rows(i).Cells(1).Value, String) = TagName) And
                           (CType(DG1.Rows(i).Cells(2).Value, String) = CType(DG2.Rows(Row_Index).Cells(0).Value, String)) And
                           (CType(DG1.Rows(i).Cells(3).Value, String) = CType(DG2.Rows(Row_Index).Cells(1).Value, String)) Then
                            ShortTagName = DG1.Rows(i).Cells(3).Value
                            frmDAShortNameInput.ShowDialog()
                            '
                            DG1.Rows(i).Cells(3).Value = ShortTagName
                            DG1.Rows(i).Cells(4).Value = Me.sampleinterval.Value.ToString
                            flag = True
                            Exit For
                        End If
                    Next
                    dataReader.Close()
                    '
                    If flag Then
                        cmd.CommandType = System.Data.CommandType.Text
                        QueryString = "UPDATE tblOPC_DATagName  Set TagShortName = " & Quote(ShortTagName) _
                            & ", SampleInterval = " & Me.sampleinterval.Value.ToString &
                            ", ServerName = " & Quote(OPC_ServerName) &
                            ", HostAddress = " & Quote(OPC_HostAddress) &
                            " WHERE TagName = " & Quote(TagName)
                        cmd.CommandText = QueryString
                        cmd.ExecuteNonQuery()
                    Else
                        Call ReportEvent("Tag not found in TagTable", "")
                    End If
                Else
                    dataReader.Close()
                    '
                    If IsNothing(TagTable) Then
                        ReDim TagTable(0)
                    Else
                        ReDim Preserve TagTable(TagTable.Length)
                    End If
                    i = TagTable.Length - 1
                    '
                    ShortTagName = ""
                    frmDAShortNameInput.ShowDialog()
                    '
                    TagTable(i).TagName = TagName
                    TagTable(i).TagShort = ShortTagName
                    TagTable(i).ServerName = OPC_ServerName
                    TagTable(i).HostAddress = OPC_HostAddress
                    TagTable(i).Interval = CInt(Me.sampleinterval.Value)
                    '
                    i = DG1.Rows.Count
                    i = TagTable.Length - 1
                    Dim row As String() = New String() {(i + 1).ToString,
                            TagTable(i).TagName,
                            TagTable(i).HostAddress,
                            TagTable(i).ServerName,
                            TagTable(i).TagShort,
                            TagTable(i).Interval.ToString, "", "", ""}

                    DG1.Rows.Add(row)
                    '
                    cmd.CommandType = System.Data.CommandType.Text
                    QueryString = "INSERT INTO tblOPC_DATagName (TagName,TagShortName,ServerName,HostAddress,SampleInterval) Values (" & Quote(TagName) & " ," &
                        Quote(ShortTagName) & " ," & Quote(OPC_ServerName) & " ," & Quote(OPC_HostAddress) & " ," & Me.sampleinterval.Value.ToString & ")"
                    cmd.CommandText = QueryString
                    cmd.ExecuteNonQuery()
                End If
            End Using
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message & "- '" & QueryString & "'", "Add_NewTagItem")
        End Try
    End Sub
    '
    Sub Read_ExternalSyncTable()
        Dim dataReader As SqlDataReader
        Dim j As Short
        '
        Try
            Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                If conn.State <> Data.ConnectionState.Open Then conn.Open()
                cmd.CommandType = System.Data.CommandType.Text
                cmd.CommandText = "SELECT * FROM ExternalDataSync"
                dataReader = cmd.ExecuteReader
                If dataReader.HasRows Then
                    Do While dataReader.Read()
                        For j = 0 To TagTable.Length - 1
                            If TagTable(j).TagShort.ToLower = dataReader("DataName").ToString.ToLower.Trim Then
                                DG1.Rows(j).Cells(6).Value = dataReader("DataSingle")
                                DG1.Rows(j).Cells(7).Value = "-----"
                                DG1.Rows(j).Cells(8).Value = dataReader("DataDate")
                            End If
                        Next
                    Loop
                End If
                dataReader.Close()
            End Using
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message & vbTab, "Read_ExternalSynctable")
        End Try
    End Sub
    '
    Sub Add_NewServer()
        Dim dataReader As SqlDataReader
        Dim i As Short
        Dim flag As Boolean
        Dim QueryString As String = ""
        '
        Try
            Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                cmd.CommandType = System.Data.CommandType.Text
                QueryString = "SELECT * FROM tblOPC_DAServer Where (OPC_Servername = " & Quote(OPC_ServerName) & "And OPC_HostAddress = " & Quote(OPC_HostAddress) & ")"
                cmd.CommandText = QueryString
                dataReader = cmd.ExecuteReader
                If dataReader.HasRows Then
                    flag = False
                    '
                    For i = 0 To ServerTable.Length - 1            'Find the row where the server resides
                        If (CType(DG2.Rows(i).Cells(0).Value.ToString.Trim, String) = OPC_ServerName) And (CType(DG2.Rows(i).Cells(1).Value.ToString.Trim, String) = OPC_HostAddress) Then
                            DG2.Rows(i).Cells(1).Value = OPC_HostAddress
                            ServerTable(i).HostAddress = OPC_HostAddress
                            flag = True
                            Exit For
                        End If
                    Next
                    dataReader.Close()
                    '
                    If flag Then
                        cmd.CommandType = System.Data.CommandType.Text
                        QueryString = "UPDATE tblOPC_DAServer Set OPC_HostAddress = " & Quote(OPC_HostAddress) & " WHERE OPC_Servername = " & Quote(OPC_ServerName)
                        cmd.CommandText = QueryString
                        cmd.ExecuteNonQuery()
                    Else
                        Call ReportEvent("Server not found in ServerTable", "")
                    End If
                Else
                    dataReader.Close()

                    If IsNothing(ServerTable) Then
                        i = 0
                    Else
                        i = ServerTable.Length
                    End If
                    '
                    ReDim Preserve ServerTable(i)
                    ServerTable(i).ServerName = OPC_ServerName
                    ServerTable(i).HostAddress = OPC_HostAddress
                    '
                    DG2.Rows.Add()
                    i = ServerTable.Length - 1
                    DG2.Rows(i).Cells(0).Value = ServerTable(i).ServerName
                    DG2.Rows(i).Cells(1).Value = ServerTable(i).HostAddress
                    '
                    cmd.CommandType = System.Data.CommandType.Text
                    QueryString = "INSERT INTO tblOPC_DAServer (OPC_Servername, OPC_HostAddress) Values (" & Quote(OPC_ServerName) & "," &
                        Quote(OPC_HostAddress) & ")"
                    '
                    cmd.CommandText = QueryString
                    cmd.ExecuteNonQuery()
                End If
            End Using
            DG2.Rows(ServerTable.Length - 1).Selected = True
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message & "'" & QueryString & "'", "Add_NewServer")
        End Try
    End Sub
    '
    Private Sub btnServer_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles btnServer.Click
        ''
        Try
            OPC_ServerName = Me.txtServerName.Text.Trim
            OPC_HostAddress = Me.txtHostAddress.Text.Trim
            Call ReportEvent(Me.txtHostAddress.Text & ":" & Me.txtServerName.Text, "")
            SaveSetting("DCMS", "COMMON", "OPC_DAClient_ServerName", OPC_ServerName)
            SaveSetting("DCMS", "COMMON", "OPC_DAClient_HostAddress", OPC_HostAddress)
            Me.btnNode.Enabled = True
            Me.btnStart.Enabled = True
            '
            Call Add_NewServer()
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, System.Reflection.MethodBase.GetCurrentMethod.DeclaringType.Name & " / " & System.Reflection.MethodBase.GetCurrentMethod().Name)
        End Try
    End Sub
    '
    Private Sub btnAddTag_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles btnNode.Click
        '
        Try
            If Not IsNothing(Entered_Tagname) Then
                Entered_Tagname = Entered_Tagname.Replace(" ", "")
                Call Add_NewTagItem(Entered_Tagname)
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, System.Reflection.MethodBase.GetCurrentMethod.DeclaringType.Name & " / " & System.Reflection.MethodBase.GetCurrentMethod().Name)
        End Try
    End Sub
    '
    Private Sub Timermessages_Tick(sender As Object, e As EventArgs) Handles Timermessages.Tick
        Dim i As Integer
        Dim strA As String
        '
        Try
            Timermessages.Enabled = False
            If MsgPointer > 0 Then
                For i = 0 To MsgPointer - 1
                    If Messages(i).Routine.Length > 0 Then strA = "" & Messages(i).Routine Else strA = ""
                    Call LogTraceMessage(Messages(i).Message & strA, Me.txtTraceMsgs)
                Next i
                MsgPointer = 0
                Erase Messages
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "frmDCMSMain.msgTimer_Tick")
        Finally
            Timermessages.Enabled = True
        End Try
    End Sub
    '
    Private Sub DG1_RowsRemoved(sender As Object, e As DataGridViewRowsRemovedEventArgs) Handles DG1.RowsRemoved
        Try
            If Not Remove_in_Progress Then
                If Not IsNothing(TagTable) Then
                    Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                        cmd.CommandType = System.Data.CommandType.Text
                        cmd.CommandText = "Delete FROM tblOPC_DATagName Where TagName = " & Quote(TagTable(e.RowIndex).TagName)
                        cmd.ExecuteNonQuery()
                    End Using
                    '
                    Remove_in_Progress = True
                    Call Read_TAGTable()
                    Remove_in_Progress = False
                    DG1_Row_Index = 0
                    DG1.Rows(DG1_Row_Index).Selected = True
                End If
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "DG1_RowsRemoved")
        End Try
    End Sub
    '
    Private Sub DG1_CellValidated(sender As Object, e As DataGridViewCellEventArgs) Handles DG1.CellValidated
        Dim strA As String = ""
        '
        Try
            DG1.Refresh()
            '
            If Not IsNothing(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value) Then
                DG1_Row_Index = e.RowIndex
                Select Case e.ColumnIndex
                    Case 1
                        'Call Add_NewTagItem(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value.ToString.Trim)
                    Case 2
                        If DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value.ToString.Trim <> TagTable(e.RowIndex).TagShort.Trim Then
                            TagTable(e.RowIndex).TagShort = DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value.ToString.Trim
                            strA = "UPDATE tblOPC_DATagName Set TagShortName = " & Quote(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value.ToString.Trim) _
                           & " WHERE TagName = " & Quote(DG1.Rows(e.RowIndex).Cells(1).Value.ToString.Trim)
                        End If
                    '
                    Case 3
                        If CInt(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value) <> TagTable(e.RowIndex).Interval Then
                            TagTable(e.RowIndex).Interval = CInt(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value)
                            strA = "UPDATE tblOPC_DATagName Set SampleInterval = " & Quote(DG1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value.ToString.Trim) _
                         & " WHERE TagName = " & Quote(DG1.Rows(e.RowIndex).Cells(1).Value.ToString.Trim)
                        End If
                        '
                    Case Else
                End Select
                '
                If strA.Length > 0 Then
                    Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                        cmd.CommandType = System.Data.CommandType.Text
                        cmd.CommandText = strA
                        cmd.ExecuteNonQuery()
                    End Using
                End If
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "DG1_CellValidated")
        End Try
    End Sub

    Private Sub DAClient1_ItemChanged(sender As Object, e As EasyDAItemChangedEventArgs)
        Dim strerr As String = "0"
        Try
            If Not IsNothing(e) Then
                strerr = "001"
                If Not IsNothing(e.ErrorId) Then
                    strerr = "001.5"
                    If e.ErrorId.Length > 0 Then
                        strerr = "002"
                        If Verbose_Messaging Then Call Log_Message3("DA_Client1 Error Itemchanged-: " & e.ErrorId.ToString & vbTab & e.ErrorMessage)
                        strerr = "003"
                    End If
                Else
                    If Verbose_Messaging Then Call Log_Message3("e.ErrorID is null")
                End If
                '
                If Not IsDBNull(e.Arguments) Then
                    strerr = "004"
                    If Verbose_Messaging Then Call Log_Message3("DA_Client1 Itemchanged- e: " & e.Arguments.ToString)
                    '
                    strerr = "005"
                    If Not IsNothing(e.Vtq) Then
                        strerr = "006"
                        If Verbose_Messaging Then Call Log_Message3("DA_Client1 Itemchanged- e.VTQ: " & e.Vtq.ToString)
                        strerr = "007"
                    Else
                        strerr = "007.5"
                        If Verbose_Messaging Then Call Log_Message3("e.VTQ is null")
                        strerr = "008"
                    End If
                Else
                    strerr = "009"
                    If Verbose_Messaging Then Call Log_Message3("DA_Client1 arguments are null")
                    strerr = "010"
                End If
            Else
                If Verbose_Messaging Then Call Log_Message3("e is null)")
            End If

            strerr = "012"
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message & ", " & strerr, "DataChangeNotification")
        End Try
    End Sub
    '
    Private Sub DAClient1_ItemChanged2(sender As Object, e As EasyDAItemChangedEventArgs) Handles DAClient1.ItemChanged
        Dim i As Short
        Dim flag As Boolean
        Dim bln As Boolean
        Dim x As Single
        Dim strerr As String = "0"
        '
        Try
            If Not IsNothing(e) Then
                strerr = "001"
                If Verbose_Messaging Then Call Log_Message3("DAClient1.ItemChanged Event - e: " & e.Arguments.ToString)
                '
                If IsNothing(e.ErrorId) Then
                    If Not IsNothing(e.Vtq) Then
                        For i = 0 To TagTable.Length - 1
                            strerr = "002"
                            If e.Arguments.ItemDescriptor.ItemId.Trim = TagTable(i).TagName.Trim Then
                                strerr = "003"
                                If Verbose_Messaging Then Call Log_Message3("DAClient1.ItemChanged Event - matched : " & e.Arguments.ItemDescriptor.ItemId.Trim)
                                strerr = "004"
                                DG1.Rows(i).Cells(7).Value = e.Vtq.Quality.ToString
                                strerr = "005"
                                DG1.Rows(i).Cells(8).Value = e.Vtq.Timestamp.ToString
                                strerr = "006"
                                '
                                If e.Vtq.ValueType = GetType(Boolean) Then
                                    bln = CBool(e.Vtq.Value)
                                    If bln Then
                                        Log_Message3("DAClient1.ItemChanged Event - HMD True")
                                        x = 5
                                    Else
                                        Log_Message3("DAClient1.ItemChanged Event - HMD False")
                                        x = 0
                                    End If
                                Else
                                    If IsNumeric(e.Vtq.Value) Then
                                        strerr = "007"
                                        x = CSng(e.Vtq.Value)
                                    End If
                                    strerr = "008"
                                    If Verbose_Messaging Then Call Log_Message3("DAClient1.ItemChanged Event - Value: " & e.Vtq.Value.ToString)
                                End If
                                '
                                strerr = "009"
                                DG1.Rows(i).Cells(6).Value = FormatNumber(x, 4)
                                strerr = "010"
                                DataSync(TagTable(i).TagShort, x)
                                strerr = "011"
                                flag = True
                                Exit For
                            End If
                        Next
                        strerr = "012"
                        '
                        If Not flag Then
                            Call ReportEvent("No TagName found: " & e.Arguments.ItemDescriptor.ItemId, "DAClient1.DataChangeNotification")
                        End If
                    Else
                        Log_Message3("DAClient1.ItemChanged Event - e.Vtq is Null, e.ErrorID: " & e.ErrorId & vbTab & e.ErrorMessage)
                    End If
                Else
                    Call ReportEvent("DAClient1.ItemChanged Event  - Error ID: " & e.ErrorId & vbTab & "Message: " & e.ErrorMessage, "")
                End If
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message & ", " & strerr, "DataChangeNotification")
        End Try
    End Sub
    Private Sub DG2_CellValidated(sender As Object, e As DataGridViewCellEventArgs) Handles DG2.CellValidated
        Dim strQuery As String = ""
        '
        Try
            DG2.Refresh()
            If Not IsNothing(DG2.Rows(e.RowIndex).Cells(e.ColumnIndex).Value) Then
                Row_Index = e.RowIndex
                Select Case e.ColumnIndex
                    Case 1
                        If DG2.Rows(Row_Index).Cells(1).Value.ToString.ToLower.Trim <> ServerTable(Row_Index).HostAddress.ToLower.Trim Then
                            ServerTable(Row_Index).HostAddress = DG2.Rows(Row_Index).Cells(1).Value.ToString.Trim
                            strQuery = "UPDATE tblOPC_DAServer SetOPC_HostAddress = " & Quote(DG2.Rows(Row_Index).Cells(1).Value.ToString.Trim) _
                      & " WHERE OPC_ServerName = " & Quote(DG2.Rows(Row_Index).Cells(0).Value.ToString.Trim)
                        End If
                    Case Else
                End Select
                '
                If strQuery.Length > 0 Then
                    Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                        If conn.State <> Data.ConnectionState.Open Then conn.Open()
                        cmd.CommandType = System.Data.CommandType.Text
                        cmd.CommandText = strQuery
                        cmd.ExecuteNonQuery()
                    End Using
                End If
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "DG1_CellValidated")
        End Try
    End Sub

    Private Sub DG2_RowsRemoved(sender As Object, e As DataGridViewRowsRemovedEventArgs) Handles DG2.RowsRemoved
        Try
            If Not Remove_in_Progress Then
                Using cmd As Data.SqlClient.SqlCommand = conn.CreateCommand
                    cmd.CommandType = System.Data.CommandType.Text
                    cmd.CommandText = "Delete FROM tblOPC_DAServer Where (OPC_ServerName = " & Quote(ServerTable(e.RowIndex).ServerName) & " AND OPC_HostAddress =" & Quote(OPC_HostAddress) & ")"
                    cmd.ExecuteNonQuery()
                End Using
                '
                Remove_in_Progress = True
                Call Read_ServerTable()
                Remove_in_Progress = False
                Row_Index = 0
                DG2.Rows(Row_Index).Selected = True
            End If
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "DG2_RowsRemoved")
        End Try
    End Sub

    Private Sub DG2_RowHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DG2.RowHeaderMouseClick
        Row_Index = e.RowIndex
        If Not IsNothing(ServerTable) Then
            If ServerTable.Length > 0 Then
                OPC_ServerName = DG2.Rows(Row_Index).Cells(0).Value
                OPC_HostAddress = DG2.Rows(Row_Index).Cells(1).Value
                Me.txtServerName.Text = OPC_ServerName
                Me.txtHostAddress.Text = OPC_HostAddress
            End If
        End If
    End Sub
    '
    Private Sub btnStartService_Click(sender As Object, e As EventArgs) Handles btnStartService.Click
        Dim sc As New ServiceController("OPC_DAClient")
        Dim TP As TimeSpan
        '
        Try
            btnStart.Enabled = False
            btnStop.Enabled = False
            btnServer.Enabled = False
            btnNode.Enabled = False
            btnStartService.Enabled = False
            btnStopService.Enabled = True
            TP = New TimeSpan(0, 1, 0)
            If sc.Status = ServiceControllerStatus.Running Then
                sc.Stop()
                sc.WaitForStatus(ServiceControllerStatus.Stopped, TP)
                sc.Start()
            Else
                sc.Start()
            End If
            '
            Me.lblService.Text = "Status: Running"
            Me.lblService.ForeColor = Color.Green
            DoEvents()
            '
            sc.WaitForStatus(ServiceControllerStatus.Running, TP)
            Call ReportEvent("Service Running", "")
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "btnStartService")
        End Try
    End Sub

    Private Sub btnStopService_Click(sender As Object, e As EventArgs) Handles btnStopService.Click
        Dim TP As TimeSpan
        Dim sc As New ServiceController("OPC_DAClient")
        '
        Try
            If sc.Status = ServiceControllerStatus.Running Then
                sc.Stop()
            End If
            '
            TP = New TimeSpan(0, 1, 0)
            sc.WaitForStatus(ServiceControllerStatus.Stopped, TP)
            Call ReportEvent("Service Stopped", "")
            Me.lblService.ForeColor = Color.Red
            DoEvents()
            btnStart.Enabled = True
            btnStop.Enabled = True
            btnServer.Enabled = True
            btnNode.Enabled = True
            btnStartService.Enabled = True
            btnStopService.Enabled = False
            '
        Catch ex As Exception
            Call ReportEvent(ex.Message, "btnSopService")
        End Try
    End Sub

    Private Sub chkReadExternalTable_CheckedChanged(sender As Object, e As EventArgs) Handles chkReadExternalTable.CheckedChanged
        If chkReadExternalTable.Checked Then
            Me.Timer_ReadExternalTable.Interval = 1000
            Me.Timer_ReadExternalTable.Enabled = True
        Else
            Me.Timer_ReadExternalTable.Enabled = False
        End If
    End Sub
    '
    Private Sub Timer_ReadExternalTable_Tick(sender As Object, e As EventArgs) Handles Timer_ReadExternalTable.Tick
        Call Read_ExternalSyncTable()
    End Sub
    '
    Private Sub frmUAClient_UI_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        conn.Close()
    End Sub
    '
    Private Sub DG1_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DG1.CellClick
        DG1_Row_Index = DG1.CurrentCell.RowIndex
        DG1.Rows(DG1_Row_Index).Selected = True
    End Sub

    Private Sub DG2_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DG2.CellClick
        Row_Index = DG2.CurrentCell.RowIndex
        DG2.Rows(Row_Index).Selected = True
    End Sub
    '
    Private Sub txtTagName_LostFocus(sender As Object, ByVal e As EventArgs) Handles txtTagName.LostFocus
        If txtTagName.Text.Trim.Length > 0 Then
            Entered_Tagname = txtTagName.Text.Trim
        End If
    End Sub
    Private Sub txtTagName_KeyPress(sender As Object, ByVal e As KeyPressEventArgs) Handles txtTagName.KeyPress
        If e.KeyChar = vbCr Then
            If txtTagName.Text.Trim.Length > 0 Then
                Entered_Tagname = txtTagName.Text.Trim
            End If
        End If
    End Sub
    '
    Private Sub txtServerName_KeyPress(sender As Object, ByVal e As KeyPressEventArgs) Handles txtServerName.KeyPress
        If e.KeyChar = vbCr Then
            OPC_ServerName = txtServerName.Text.Trim
        End If
    End Sub
    Private Sub txtServerName_LostFocus(sender As Object, ByVal e As EventArgs) Handles txtServerName.LostFocus
        If txtServerName.Text.Trim.Length > 0 Then
            OPC_ServerName = txtServerName.Text.Trim
        End If
    End Sub
    '
    Private Sub txtHostAddress_KeyPress(sender As Object, ByVal e As KeyPressEventArgs) Handles txtHostAddress.KeyPress
        If e.KeyChar = vbCr Then
            OPC_HostAddress = txtHostAddress.Text.Trim
        End If
    End Sub
    '
    Private Sub txtHostAddress_LostFocus(sender As Object, ByVal e As EventArgs) Handles txtHostAddress.LostFocus
        If txtHostAddress.Text.Trim.Length > 0 Then
            OPC_HostAddress = txtHostAddress.Text.Trim
        End If
    End Sub

    Private Sub DG2_RowEnter(sender As Object, e As DataGridViewCellEventArgs) Handles DG2.RowEnter
        OPC_ServerName = ServerTable(e.RowIndex).ServerName
        OPC_HostAddress = ServerTable(e.RowIndex).HostAddress
        SaveSetting("DCMS", "COMMON", "OPC_DAClient_ServerName", OPC_ServerName)
        SaveSetting("DCMS", "COMMON", "OPC_DAClient_HostAddress", OPC_HostAddress)
    End Sub

    Private Sub chkverbose_CheckedChanged(sender As Object, e As EventArgs) Handles chkverbose.CheckedChanged
        If Me.chkverbose.Checked Then
            Verbose_Messaging = True
        Else
            Verbose_Messaging = False
        End If
    End Sub

    Private Sub btnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        MsgPointer = 0
        Erase Messages
        Me.txtTraceMsgs.Text = ""
    End Sub
End Class